// Inputs
long input(0) cmd;
//array input(1) u;
//array input(2) z;
//array input(3) x;
//array input(4) f_h;
//array input(5) df_dh;
// Outputs
//ref	output(0) this;

#define ARR_U 1
#define ARR_Z 2
#define ARR_X 3
#define ARR_F 4
#define ARR_DF 5

#define CNT_U 2
#define CNT_Z 2
#define CNT_X 4

long main(void)
{
	double value;
	//Trace(1,cmd);
	switch(cmd)
	{
	case 0:	// Compute and set f(x,u) and df(x,u)/dx
		// First, check the dimensions of the arrays - can be skipped
		// A vector in REX is a column (a matrix with a single column)
		if(GetInArrRows(ARR_U)<CNT_U || GetInArrRows(ARR_X)<CNT_X || GetInArrRows(ARR_F)<CNT_X || GetInArrRows(ARR_DF)<CNT_X || GetInArrCols(ARR_DF)<CNT_X)
		{
			TraceWarning(11,GetInArrRows(ARR_U));
			TraceWarning(12,GetInArrRows(ARR_X));
			TraceWarning(13,GetInArrRows(ARR_F));
			TraceWarning(14,GetInArrRows(ARR_DF));
			TraceWarning(15,GetInArrCols(ARR_DF));
		}
		// A simple linear system is used in this example
		SetInArrValue(ARR_F,0,0,GetInArrDouble(ARR_X,1,0)-GetInArrDouble(ARR_X,0,0));
		SetInArrValue(ARR_F,1,0,GetInArrDouble(ARR_X,2,0)-GetInArrDouble(ARR_X,1,0));
		SetInArrValue(ARR_F,2,0,GetInArrDouble(ARR_X,3,0)-GetInArrDouble(ARR_X,2,0));
		SetInArrValue(ARR_F,3,0,GetInArrDouble(ARR_U,0,0)-GetInArrDouble(ARR_X,3,0));
		
		SetInArrValue(ARR_DF,0,0,-1.0);
		SetInArrValue(ARR_DF,0,1,1.0);
		SetInArrValue(ARR_DF,0,2,0.0);
		SetInArrValue(ARR_DF,0,3,0.0);

		SetInArrValue(ARR_DF,1,0,0.0);
		SetInArrValue(ARR_DF,1,1,-1.0);
		SetInArrValue(ARR_DF,1,2,1.0);
		SetInArrValue(ARR_DF,1,3,0.0);

		SetInArrValue(ARR_DF,2,0,0.0);
		SetInArrValue(ARR_DF,2,1,0.0);
		SetInArrValue(ARR_DF,2,2,-1.0);
		SetInArrValue(ARR_DF,2,3,1.0);

		SetInArrValue(ARR_DF,3,0,-0.0);
		SetInArrValue(ARR_DF,3,1,-0.0);
		SetInArrValue(ARR_DF,3,2,-0.0);
		SetInArrValue(ARR_DF,3,3,-1.0);
		break;
	case 1:	// Compute and set h1(x) and dh1(x)/dx; e.g., first set of output measurements (for EKF input: nz = 1)
		// Outputs just linearly depend on state variables in this example		
		value = 2.0*GetInArrDouble(ARR_X,1,0) + 0.5*GetInArrDouble(ARR_X,3,0);
		SetInArrValue(ARR_F,0,0,GetInArrDouble(ARR_X,0,0));
		SetInArrValue(ARR_F,1,0,value);

		SetInArrValue(ARR_DF,0,0,1.0);
		SetInArrValue(ARR_DF,0,1,0.0);
		SetInArrValue(ARR_DF,0,2,0.0);
		SetInArrValue(ARR_DF,0,3,0.0);

		SetInArrValue(ARR_DF,1,0,0.0);
		SetInArrValue(ARR_DF,1,1,2.0);
		SetInArrValue(ARR_DF,1,2,0.0);
		SetInArrValue(ARR_DF,1,3,0.5);
		break;
	case 2:	// Compute and set h2(x) and dh2(x)/dx; e.g., second set of output measurements (for EKF input: nz = 2)
		// Not used in this example
		break;
	default:
		//TraceError(2,cmd);
		return -1;
	}
	// The vector z is not needed in a linear case; however, since it is connected in the example, it must be used
	// (because input arrays have implicit declaration)
	TraceVerbose(20,GetInArrDouble(ARR_Z,0,0)); 
	return 0;
}
